# constraints.nu -- 内建约束定义
#
# Copyright (C) 2022 KAAAsS

# 操作系统相关约束
module os {
    export def linux [] {
        if (which uname | is-empty) {
            false
        } else {
            (uname | get kernel-name) == "Linux"
        }
    }

    export def darwin [] {
        if (which uname | is-empty) {
            false
        } else {
            (uname | get kernel-name) == "Darwin"
        }
    }
}

export use os

# 图形界面约束
export def gui [] {
    use pkg.nu

    if (os linux) {
        # Linux 暂时只考虑 X11
        pkg check_install? libxrandr
    } else if (os darwin) {
        # MacOS 都是图形界面
        true
    } else {
        false
    }
}

# 获得默认的约束
export def default_constraints [] {
    {
        "gui": {|| gui },
        "false": {|| false },

        # 操作系统
        "os/linux": {|| os linux },
        "os/darwin": {|| os darwin },
    }
}
